/*
 * Copyright (C) 2013 Google Inc. All rights reserved.
 * Copyright (C) 2013-2016 Apple Inc. All rights reserved.
 * Copyright (C) 2014 University of Washington. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

// DO NOT EDIT THIS FILE. It is automatically generated from CombinedWebDriverBidiDomains.json by the script: Source/JavaScriptCore/inspector/scripts/generate-inspector-protocol-bindings.py

#pragma once

#include <JavaScriptCore/InspectorProtocolTypes.h>
#include <wtf/JSONValues.h>
#include <wtf/text/WTFString.h>

namespace Inspector {



namespace Protocol {



// Forward declarations.
#if ENABLE(WEBDRIVER_BIDI)
namespace BidiBrowsingContext {
enum class ReadinessState;
} // BidiBrowsingContext
#endif // ENABLE(WEBDRIVER_BIDI)
// End of forward declarations.


// Typedefs.
#if ENABLE(WEBDRIVER_BIDI)
namespace BidiBrowsingContext {
/* A unique identifier for a navigable. */
using BrowsingContext = String;
/* Unique string identifying an ongoing navigation. */
using Navigation = String;
} // BidiBrowsingContext
#endif // ENABLE(WEBDRIVER_BIDI)
// End of typedefs.

namespace WebDriverBidiHelpers {

String getEnumConstantValue(int code);

template<typename T> String getEnumConstantValue(T enumValue)
{
    return getEnumConstantValue(static_cast<int>(enumValue));
}

} // namespace WebDriverBidiHelpers

#if ENABLE(WEBDRIVER_BIDI)
namespace BidiBrowsingContext {

/* Represents the stage of document loading at which a navigation command will return. */
enum class ReadinessState {
    None = 0,
    Interactive = 1,
    Complete = 2,
}; // enum class ReadinessState

} // BidiBrowsingContext
#endif // ENABLE(WEBDRIVER_BIDI)



namespace WebDriverBidiHelpers {

template<typename ProtocolEnumType>
std::optional<ProtocolEnumType> parseEnumValueFromString(const String&);

#if ENABLE(WEBDRIVER_BIDI)
// Enums in the 'BidiBrowsingContext' Domain
template<>
std::optional<Protocol::BidiBrowsingContext::ReadinessState> parseEnumValueFromString<Protocol::BidiBrowsingContext::ReadinessState>(const String&);
#endif // ENABLE(WEBDRIVER_BIDI)

} // namespace WebDriverBidiHelpers

} // namespace Protocol

} // namespace Inspector

namespace WTF {

template<typename T> struct DefaultHash;
#if ENABLE(WEBDRIVER_BIDI)

// Hash declarations in the 'BidiBrowsingContext' Domain
template<>
struct DefaultHash<Inspector::Protocol::BidiBrowsingContext::ReadinessState> : IntHash<Inspector::Protocol::BidiBrowsingContext::ReadinessState> { };
#endif // ENABLE(WEBDRIVER_BIDI)

} // namespace WTF
